// This file is generated by kconfig_compiler_kf5 from kopetechatwindowsettings.kcfg.
// All changes you do to this file will be lost.
#ifndef KOPETECHATWINDOWSETTINGS_H
#define KOPETECHATWINDOWSETTINGS_H

#include <kopetechatwindow_shared_export.h>

#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>
#include <QSet>

#include <kglobalsettings.h>
#include <kcolorscheme.h>

class KOPETECHATWINDOW_SHARED_EXPORT KopeteChatWindowSettings : public KConfigSkeleton
{
  Q_OBJECT
  public:

    static KopeteChatWindowSettings *self();
    ~KopeteChatWindowSettings() override;

    /**
      Set Name of a Adium/Kopete chat window style.
    */
    static
    void setStyleName( const QString & v )
    {
      if (v != self()->mStyleName && !self()->isStyleNameImmutable()) {
        self()->mStyleName = v;
        self()->mSettingsChanged.insert(signalStyleChanged);
      }
    }

    /**
      Get Name of a Adium/Kopete chat window style.
    */
    static
    QString styleName()
    {
      return self()->mStyleName;
    }

    /**
      Is Name of a Adium/Kopete chat window style. Immutable
    */
    static
    bool isStyleNameImmutable()
    {
      return self()->isImmutable( QStringLiteral( "styleName" ) );
    }

    /**
      Set Relative path to a CSS variant for the current style.
    */
    static
    void setStyleVariant( const QString & v )
    {
      if (!self()->isStyleVariantImmutable())
        self()->mStyleVariant = v;
    }

    /**
      Get Relative path to a CSS variant for the current style.
    */
    static
    QString styleVariant()
    {
      return self()->mStyleVariant;
    }

    /**
      Is Relative path to a CSS variant for the current style. Immutable
    */
    static
    bool isStyleVariantImmutable()
    {
      return self()->isImmutable( QStringLiteral( "styleVariant" ) );
    }

    /**
      Set Group consecutive messages from the same user as one block.
    */
    static
    void setGroupConsecutiveMessages( bool v )
    {
      if (!self()->isGroupConsecutiveMessagesImmutable())
        self()->mGroupConsecutiveMessages = v;
    }

    /**
      Get Group consecutive messages from the same user as one block.
    */
    static
    bool groupConsecutiveMessages()
    {
      return self()->mGroupConsecutiveMessages;
    }

    /**
      Is Group consecutive messages from the same user as one block. Immutable
    */
    static
    bool isGroupConsecutiveMessagesImmutable()
    {
      return self()->isImmutable( QStringLiteral( "groupConsecutiveMessages" ) );
    }

    /**
      Set Use a compact variant of the chat style for chatrooms.
    */
    static
    void setUseCompact( bool v )
    {
      if (!self()->isUseCompactImmutable())
        self()->mUseCompact = v;
    }

    /**
      Get Use a compact variant of the chat style for chatrooms.
    */
    static
    bool useCompact()
    {
      return self()->mUseCompact;
    }

    /**
      Is Use a compact variant of the chat style for chatrooms. Immutable
    */
    static
    bool isUseCompactImmutable()
    {
      return self()->isImmutable( QStringLiteral( "useCompact" ) );
    }

    /**
      Set Text color used when highlighting.
    */
    static
    void setHighlightForegroundColor( const QColor & v )
    {
      if (v != self()->mHighlightForegroundColor && !self()->isHighlightForegroundColorImmutable()) {
        self()->mHighlightForegroundColor = v;
        self()->mSettingsChanged.insert(signalChatwindowAppearanceChanged);
      }
    }

    /**
      Get Text color used when highlighting.
    */
    static
    QColor highlightForegroundColor()
    {
      return self()->mHighlightForegroundColor;
    }

    /**
      Is Text color used when highlighting. Immutable
    */
    static
    bool isHighlightForegroundColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "highlightForegroundColor" ) );
    }

    /**
      Set Background color used when highlighting.
    */
    static
    void setHighlightBackgroundColor( const QColor & v )
    {
      if (v != self()->mHighlightBackgroundColor && !self()->isHighlightBackgroundColorImmutable()) {
        self()->mHighlightBackgroundColor = v;
        self()->mSettingsChanged.insert(signalChatwindowAppearanceChanged);
      }
    }

    /**
      Get Background color used when highlighting.
    */
    static
    QColor highlightBackgroundColor()
    {
      return self()->mHighlightBackgroundColor;
    }

    /**
      Is Background color used when highlighting. Immutable
    */
    static
    bool isHighlightBackgroundColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "highlightBackgroundColor" ) );
    }

    /**
      Set Disable custom formatting set by users.
    */
    static
    void setChatFmtOverride( bool v )
    {
      if (v != self()->mChatFmtOverride && !self()->isChatFmtOverrideImmutable()) {
        self()->mChatFmtOverride = v;
        self()->mSettingsChanged.insert(signalMessageOverridesChanged);
      }
    }

    /**
      Get Disable custom formatting set by users.
    */
    static
    bool chatFmtOverride()
    {
      return self()->mChatFmtOverride;
    }

    /**
      Is Disable custom formatting set by users. Immutable
    */
    static
    bool isChatFmtOverrideImmutable()
    {
      return self()->isImmutable( QStringLiteral( "chatFmtOverride" ) );
    }

    /**
      Set Chat text color.
    */
    static
    void setChatTextColor( const QColor & v )
    {
      if (v != self()->mChatTextColor && !self()->isChatTextColorImmutable()) {
        self()->mChatTextColor = v;
        self()->mSettingsChanged.insert(signalChatwindowAppearanceChanged);
      }
    }

    /**
      Get Chat text color.
    */
    static
    QColor chatTextColor()
    {
      return self()->mChatTextColor;
    }

    /**
      Is Chat text color. Immutable
    */
    static
    bool isChatTextColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "chatTextColor" ) );
    }

    /**
      Set Chat background color.
    */
    static
    void setChatBackgroundColor( const QColor & v )
    {
      if (v != self()->mChatBackgroundColor && !self()->isChatBackgroundColorImmutable()) {
        self()->mChatBackgroundColor = v;
        self()->mSettingsChanged.insert(signalChatwindowAppearanceChanged);
      }
    }

    /**
      Get Chat background color.
    */
    static
    QColor chatBackgroundColor()
    {
      return self()->mChatBackgroundColor;
    }

    /**
      Is Chat background color. Immutable
    */
    static
    bool isChatBackgroundColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "chatBackgroundColor" ) );
    }

    /**
      Set Chat link color.
    */
    static
    void setChatLinkColor( const QColor & v )
    {
      if (v != self()->mChatLinkColor && !self()->isChatLinkColorImmutable()) {
        self()->mChatLinkColor = v;
        self()->mSettingsChanged.insert(signalChatwindowAppearanceChanged);
      }
    }

    /**
      Get Chat link color.
    */
    static
    QColor chatLinkColor()
    {
      return self()->mChatLinkColor;
    }

    /**
      Is Chat link color. Immutable
    */
    static
    bool isChatLinkColorImmutable()
    {
      return self()->isImmutable( QStringLiteral( "chatLinkColor" ) );
    }

    /**
      Set Chat font.
    */
    static
    void setChatFont( const QFont & v )
    {
      if (v != self()->mChatFont && !self()->isChatFontImmutable()) {
        self()->mChatFont = v;
        self()->mSettingsChanged.insert(signalChatwindowAppearanceChanged);
      }
    }

    /**
      Get Chat font.
    */
    static
    QFont chatFont()
    {
      return self()->mChatFont;
    }

    /**
      Is Chat font. Immutable
    */
    static
    bool isChatFontImmutable()
    {
      return self()->isImmutable( QStringLiteral( "chatFont" ) );
    }


    enum {
      signalChatwindowAppearanceChanged = 1,
      signalMessageOverridesChanged = 2,
      signalStyleChanged = 3,
      signalStyleVariantChanged = 4
    };

  Q_SIGNALS:
    /**
      Emitted when the font and colors settings have changed.
    */
    void chatwindowAppearanceChanged();

    /**
      Emitted when the message overrides settings have changed.
    */
    void messageOverridesChanged();

    /**
      Emitted when the chat window style has changed.
    */
    void styleChanged(const QString & styleName);

    /**
      Emitted when ChatWindowStyle variant has changed.
    */
    void styleVariantChanged(const QString & styleVariant);

  private:
    void itemChanged(quint64 signalFlag);

  protected:
    KopeteChatWindowSettings();
    friend class KopeteChatWindowSettingsHelper;

    bool usrSave() override;

    // Appearance
    QString mStyleName;
    QString mStyleVariant;
    bool mGroupConsecutiveMessages;
    bool mUseCompact;
    QColor mHighlightForegroundColor;
    QColor mHighlightBackgroundColor;
    bool mChatFmtOverride;
    QColor mChatTextColor;
    QColor mChatBackgroundColor;
    QColor mChatLinkColor;
    QFont mChatFont;

  private:
    QSet<quint64> mSettingsChanged;
};

#endif

